{-# LANGUAGE TemplateHaskell,
             FlexibleInstances,
             FlexibleContexts,
             MultiParamTypeClasses,             
             DeriveDataTypeable,
             RankNTypes,
             NoMonomorphismRestriction
 #-}

module AOP.Examples.Fib (fib, makeAspectFib)
where

import AOP.Default

fibTag = $newTag

fibBase :: (Typeable1Monad m, Num a, Num b) => Function a (m b) 
fibBase = mkFunction (\n -> return 1) fibTag

fibPc = pcCall fibBase `pcAnd` pcArgGT 2

fibAdv proceed n = do f1 <- fibBase # (n-1)
                      f2 <- fibBase # (n-2)
                      return (f1 + f2)
                   
fib = do deploy (niAspect fibPc fibAdv)
         return errorFib 
      where errorFib n = if n < 0 
                         then throwError "Not defined on negative value"
                         else fibBase # n

makeAspectFib :: (Typeable1Monad m, Typeable1Monad (t m), Num a1, Num b1, Ord a1, 
                  LessGen (a1 -> NIAOT t m b1) (a2 -> NIAOT t m b2)) => 
                 NIAdvice t a2 b2 -> Aspect (NIAOT t m) a1 (NIAOT t m b1) a2 b2
makeAspectFib adv = niAspect fibPc adv

runMemo c = runIdentity (runErrorT (runNIAOT c))

program n = runMemo $ do f <- fib
                         f # n
